image: ubuntu:18.04

include:
  - project: '$CI_PROJECT_PATH' # Execute individual project's configuration (if project contains .gitlab-ci.yml)
    file: '$CI_CONFIG_PATH'
    ref: '$CI_COMMIT_REF_NAME' # Must be defined or MR pipelines always use the use default branch


stages:
  - local_build
  - local_test
  - local_scans
  - mandatory_scans

# This Semgrep scan is similar to the one GitLab uses natively, but instead of running as an internal scan, we have it configured here as an external scan. This does require a applciation token available at https://semgrep.dev/
semgrep:
  stage: mandatory_scans
  image: returntocorp/semgrep
  script: semgrep ci --gitlab-sast > semgrep-sast-report.json || true
  artifacts:
    reports:
      sast: semgrep-sast-report.json
  when: always 
#   rules:
#   - changes:
#       - .gitlab-ci.yml
#   - if: $CI_PIPELINE_SOURCE == "web"  # allow triggering a scan manually from the gitlab UI
#   - if: $CI_MERGE_REQUEST_IID
#   - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  
  variables:
    # Token and flag to enable output to JSON file. 
    SEMGREP_APP_TOKEN: a89c8041ec99a8612e1c8d2938725b8d8c0d36553662605be6e2eb5def0222d8
    SEMGREP_GITLAB_JSON: "1"

# Horusec is an open source tool for SAST scannign across multiple languages. https://horusec.io/site/
horusec:
  stage: mandatory_scans
  tags:
    - shell
  script:
    - echo HORUSEC_CLI_PRINT_OUTPUT_TYPE=json > horus_env.txt
    - echo HORUSEC_CLI_JSON_OUTPUT_FILEPATH=/src/horusec/scan_out.json >> horus_env.txt
    - sudo docker run --env-file horus_env.txt -v /var/run/docker.sock:/var/run/docker.sock         -v $(pwd):/src/horusec         horuszup/horusec-cli:latest horusec start -p /src/horusec -P $(pwd) --config-file-path=/src/horusec/horusec-config.json
# Currently the scan output is provided as an artifact, but as the JSON is not compatible with GitLab the results do not get incorporated into the vulnerability chart
  artifacts:
    paths:
      - scan_out.json
    when: on_success
    expire_in: 1 week
